#include "systems.h"
#include "system_01.h"
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
#ifndef __DDEM_INDEX_TRANSLATOR_DEF
#define __DDEM_INDEX_TRANSLATOR_DEF

#define Z(I,J) z[(J)*m + (I)]
/* Z(I,J) corresponds to y_I(alpha_J) if  0<= J < nu */
/* Z(I,J) corresponds to y'_I(alpha_J) if nu <= J < nu + omega */

#define TJAC(I) userProvidedJac->tJac[(I)]
#define YJAC(I,J) userProvidedJac->yJac[(I)*m + (J)]
#define ZJAC(I,J,K) userProvidedJac->zJac[(I)*(m*(nu+omega)) + (K)*m+(J)]
/* par F_I / par Z(J,K) */
#define PJAC(I,J) userProvidedJac->pJac[(I)*l + (J)]

#define TTJAC(I) userProvidedJac->ttJac[(I)]
#define TPJAC(I,J) userProvidedJac->tpJac[(I)*l + (J)]

#endif // __DDEM_INDEX_TRANSLATOR_DEF
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void f_01(int state, double t, int m, double* y,
										  int nu, int omega, double* z,
											int l, double* p,
											double* f,
                      ddemUserProvidedJac* userProvidedJac,
											void* comm)
{
	f[0] = Z(0,0);
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		userProvidedJac->yIndependent = DDEM_TRUE;
		ZJAC(0,0,0) = 1.0;
		userProvidedJac->pIndependent = DDEM_TRUE;
	}
}
void delayArgumentsFunc_01(double t, int m, double* y,
                                   int l, double* p,
                                   int nu, int omega, double* alpha,
                                   ddemUserProvidedJac* userProvidedJac,
																	 void* comm)
{
  alpha[0] = y[0];
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		YJAC(0,0) = 1.0;
		userProvidedJac->pIndependent = DDEM_TRUE;
	}
}
void y0Func_01(int l, double* p,
                       int m, double* y0,
                       ddemUserProvidedJac* userProvidedJac,
											 void* comm)
{
	y0[0] = p[0];
	if(userProvidedJac->needed)
	{
		PJAC(0,0) = 1.0;
	}
}
/*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/
void getSystem_01(ddemSystem* system)
{
	system->create(1, 1, 1, 0);

	system->setF(f_01);

	double h[]={0.5};
	system->setHistory(h);

	system->setT0(2.0);
	system->setT0DiscDegree(0);

	system->setY0(y0Func_01);

	system->setDelayArguments(1, 0, delayArgumentsFunc_01, DDEM_TRUE);
}
/*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/
void getSimulationA_01(double TOL, ddemSimulationAttributes* simA)
{
	simA->parameters[0] = 1.0;

	simA->tEnd = 5.5;

	simA->relTolerance = TOL;
	simA->absTolerance[0] = TOL;
}
