#include <math.h>

#include "systems.h"
#include "system_05.h"
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
#ifndef __DDEM_INDEX_TRANSLATOR_DEF
#define __DDEM_INDEX_TRANSLATOR_DEF

#define Z(I,J) z[(J)*m + (I)]
/* Z(I,J) corresponds to y_I(alpha_J) if  0<= J < nu */
/* Z(I,J) corresponds to y'_I(alpha_J) if nu <= J < nu + omega */

#define TJAC(I) userProvidedJac->tJac[(I)]
#define YJAC(I,J) userProvidedJac->yJac[(I)*m + (J)]
#define ZJAC(I,J,K) userProvidedJac->zJac[(I)*(m*(nu+omega)) + (K)*m+(J)]
/* par F_I / par Z(J,K) */
#define PJAC(I,J) userProvidedJac->pJac[(I)*l + (J)]

#define TTJAC(I) userProvidedJac->ttJac[(I)]
#define TPJAC(I,J) userProvidedJac->tpJac[(I)*l + (J)]

#endif // __DDEM_INDEX_TRANSLATOR_DEF
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void	f_05(int state, double t, int m, double* y,
										  int nu, int omega, double* z,
											int l, double* p,
											double* f,
                      ddemUserProvidedJac* userProvidedJac,
											void* comm)
{
	// fIndices = 0, 1, 2, ..., (nVariables - 1) 
	// yIndices = 0, 1, 2, ..., (nVariables - 1) 
	// alphaIndices = 0, 1, 2, ..., (nu + omega - 1) 
	// pIndices = 0, 1, 2, ..., (nParameters - 1) 
	//*******************************************
	// set f[fIndices]
  f[0] = Z(0,0) + (3 + p[0]) * pow(t, 2 + p[0]) - 
					pow(t, (3 + p[0]) * (3 + p[0]));
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		// or set TJAC(fIndices)
		// TJAC(0) = ;

		userProvidedJac->yIndependent = DDEM_TRUE;
		// or set YJAC(fIndices, yIndices)
		// YJAC(0,0) = ;

		// set ZJAC(fIndices, yIndices, alphaIndices)
		// ZJAC(0,0,0) = ;

		userProvidedJac->pIndependent = DDEM_TRUE;
		// or set PJAC(fIndices, pIndices)
		// PJAC(0,0) = ;
	}
}
/*---------------------------------------------*/
void delayArgumentsFunc_05(double t, int m, double* y,
                                   int l, double* p,
                                   int nu, int omega, double* alpha,
                                   ddemUserProvidedJac* userProvidedJac,
																	 void* comm)
{
	// alphaIndices = 0, 1, 2, ..., (nu + omega - 1) 
	// yIndices = 0, 1, 2, ..., (nVariables - 1) 
	// pIndices = 0, 1, 2, ..., (nParameters - 1) 
	//*******************************************
	// set alpha[alphaIndices]
  alpha[0] = y[0];
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		// or set TJAC(alphaIndices)
		// TJAC(0) = ;

		userProvidedJac->yIndependent = DDEM_TRUE;
		// or set YJAC(alphaIndices, yIndices)
		// YJAC(0,0) = ;

		userProvidedJac->pIndependent = DDEM_TRUE;
		// or set PJAC(alphaIndices, pIndices)
		// PJAC(0,0) = ;
	}
}
/*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/
void getSystem_05(ddemSystem* system)
{
	system->create(1, 1, 0, 0);

	system->setF(f_05);

	system->setT0(0.0);

	double y0[]={0.0};
	system->setY0(y0);

	system->setDelayArguments(1, 0, delayArgumentsFunc_05, DDEM_TRUE);
}
/*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/
void getSimulationA_05(double TOL, ddemSimulationAttributes* simA)
{
	simA->parameters[0] = 0.0;/*mu*/

	simA->tEnd = 1.0;

	simA->relTolerance = TOL;
	simA->absTolerance[0] = TOL;

	simA->vanishingConst = 1e-2;
}
