#include <math.h>

#include "systems.h"
#include "system_07.h"
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
#ifndef __DDEM_INDEX_TRANSLATOR_DEF
#define __DDEM_INDEX_TRANSLATOR_DEF

#define Z(I,J) z[(J)*m + (I)]
/* Z(I,J) corresponds to y_I(alpha_J) if  0<= J < nu */
/* Z(I,J) corresponds to y'_I(alpha_J) if nu <= J < nu + omega */

#define TJAC(I) userProvidedJac->tJac[(I)]
#define YJAC(I,J) userProvidedJac->yJac[(I)*m + (J)]
#define ZJAC(I,J,K) userProvidedJac->zJac[(I)*(m*(nu+omega)) + (K)*m+(J)]
/* par F_I / par Z(J,K) */
#define PJAC(I,J) userProvidedJac->pJac[(I)*l + (J)]

#define TTJAC(I) userProvidedJac->ttJac[(I)]
#define TPJAC(I,J) userProvidedJac->tpJac[(I)*l + (J)]

#endif // __DDEM_INDEX_TRANSLATOR_DEF
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*----------UNCOMMENT, RENAME, AND USE THE REQUIRED FUNCTIONS------------*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
double ff(double y, double* p)
{
	double a, K, r;
	a = p[5];
	K = p[6];
	r = p[7];

	return a / (1.0 + K * exp(r * log(y)));
}
void	f_07(int state, double t, int m, double* y,
										  int nu, int omega, double* z,
											int l, double* p,
											double* f,
                      ddemUserProvidedJac* userProvidedJac,
											void* comm)
{
	// fIndices = 0, 1, 2, ..., (nVariables - 1) 
	// yIndices = 0, 1, 2, ..., (nVariables - 1) 
	// alphaIndices = 0, 1, 2, ..., (nu + omega - 1) 
	// pIndices = 0, 1, 2, ..., (nParameters - 1) 
	//*******************************************
	// set f[fIndices]
	double s_0, T_1, gamma, Q, k;
	s_0 = p[0];
	T_1 = p[1];
	gamma = p[2];
	Q = p[3];
	k = p[4];

	if( t > 34.999)
	{
		t = t;
	}

  f[0] = s_0 * Z(1,0) - gamma * y[0] - Q;//s0*Z(2,1)-gamma*Y(1)-Q
  f[1] = ff(y[0], p) - k * y[1];// - k * y[1];//f(Y(1))-k*Y(2)
  f[2] = 1.0 - Q * exp(gamma * y[2]) / (s_0 * Z(1,1));//1-Q*exp(gamma*Y(3))/(s0*Z(2,2))
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		// or set TJAC(fIndices)
		// TJAC(0) = ;

		userProvidedJac->yIndependent = DDEM_TRUE;
		// or set YJAC(fIndices, yIndices)
		// YJAC(0,0) = ;

		// set ZJAC(fIndices, yIndices, alphaIndices)
		// ZJAC(0,0,0) = ;

		userProvidedJac->pIndependent = DDEM_TRUE;
		// or set PJAC(fIndices, pIndices)
		// PJAC(0,0) = ;
	}
}
/*---------------------------------------------*/
void historyFunc_07(int historySegmentIndex,
											 double t,
                       int l, double* p,
                       int m, double* h,
                       ddemUserProvidedJac* userProvidedJac,
											 void* comm)
{
	// hIndices = 0, 1, 2, ..., (nVariables - 1) 
	// pIndices = 0, 1, 2, ..., (nParameters - 1) 
	//*******************************************
	// set h[hIndices]
  h[0] = 3.325;//y_1
	if( historySegmentIndex == 1)// t < -T_1
		h[1] = 10.0;//y_2
	else
		h[1] = 9.5;//y_2
  h[2] = 120.0;//y_3
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		// or set TJAC(hIndices)
		// TJAC(0) = ;

		userProvidedJac->pIndependent = DDEM_TRUE;
		// or set PJAC(hIndices, pIndices)
		// PJAC(0,0) = ;

		if(userProvidedJac->needed2nd)
		{
			userProvidedJac->ttIndependent = DDEM_TRUE;
			// or set TTJAC(hIndices)
			// TTJAC(0) = ;
			
			userProvidedJac->tpIndependent = DDEM_TRUE;
			// or set TPJAC(hIndices, pIndices)
			// TPJAC(0,0) = ;
		}
	}
}
/*---------------------------------------------*/
void historyStartsFunc_07(int historySegmentIndex,
										int l, double* p,
                    double& historyStart,
                    ddemUserProvidedJac* userProvidedJac,
										void* comm)
{
	if(historySegmentIndex == 1)
		historyStart = -p[1];// -T_1
}
/*---------------------------------------------*/
void delayArgumentsFunc_07(double t, int m, double* y,
                                   int l, double* p,
                                   int nu, int omega, double* alpha,
                                   ddemUserProvidedJac* userProvidedJac,
																	 void* comm)
{
	// alphaIndices = 0, 1, 2, ..., (nu + omega - 1) 
	// yIndices = 0, 1, 2, ..., (nVariables - 1) 
	// pIndices = 0, 1, 2, ..., (nParameters - 1) 
	//*******************************************
	// set alpha[alphaIndices]
  alpha[0] = t - p[1];// t - T_1
  alpha[1] = t- p[1] - y[2];// t - T_1 - y_3
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		// or set TJAC(alphaIndices)
		// TJAC(0) = ;

		userProvidedJac->yIndependent = DDEM_TRUE;
		// or set YJAC(alphaIndices, yIndices)
		// YJAC(0,0) = ;

		userProvidedJac->pIndependent = DDEM_TRUE;
		// or set PJAC(alphaIndices, pIndices)
		// PJAC(0,0) = ;
	}
}
/*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/
void getSystem_07(ddemSystem* system)
{
	system->create(3, 8, 2, 0);

	system->setF(f_07);

	system->setHistory(historyFunc_07);
	system->setHistoryStarts(historyStartsFunc_07);
	int hSDD[] = {0};
	system->setHistoryStartsDiscDegrees(hSDD);

	system->setT0(0.0);

	system->setDelayArguments(2, 0, delayArgumentsFunc_07, DDEM_TRUE);
}
/*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/
void getSimulationA_07(double TOL, ddemSimulationAttributes* simA)
{
	simA->parameters[0] = 0.0031;//s_0
	simA->parameters[1] = 6.0;//T_1
	simA->parameters[2] = 0.001;//gamma
	simA->parameters[3] = 0.0275;//Q
	simA->parameters[4] = 2.8;//k
	simA->parameters[5] = 6570.0;//a
	simA->parameters[6] = 0.0382;//K
	simA->parameters[7] = 6.96;//r

	simA->tEnd = 300.0;

	simA->relTolerance = TOL;
	simA->absTolerance[0] = TOL;
	simA->absTolerance[1] = TOL;
	simA->absTolerance[2] = TOL;
}
