#include <math.h>

#include "systems.h"
#include "system_08.h"
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
#ifndef __DDEM_INDEX_TRANSLATOR_DEF
#define __DDEM_INDEX_TRANSLATOR_DEF

#define Z(I,J) z[(J)*m + (I)]
/* Z(I,J) corresponds to y_I(alpha_J) if  0<= J < nu */
/* Z(I,J) corresponds to y'_I(alpha_J) if nu <= J < nu + omega */

#define TJAC(I) userProvidedJac->tJac[(I)]
#define YJAC(I,J) userProvidedJac->yJac[(I)*m + (J)]
#define ZJAC(I,J,K) userProvidedJac->zJac[(I)*(m*(nu+omega)) + (K)*m+(J)]
/* par F_I / par Z(J,K) */
#define PJAC(I,J) userProvidedJac->pJac[(I)*l + (J)]

#define TTJAC(I) userProvidedJac->ttJac[(I)]
#define TPJAC(I,J) userProvidedJac->tpJac[(I)*l + (J)]

#endif // __DDEM_INDEX_TRANSLATOR_DEF
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*----------UNCOMMENT, RENAME, AND USE THE REQUIRED FUNCTIONS------------*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void	f_08(int state, double t, int m, double* y,
										  int nu, int omega, double* z,
											int l, double* p,
											double* f,
                      ddemUserProvidedJac* userProvidedJac,
											void* comm)
{
  double zPow = pow(Z(0,0), p[1]);
	f[0] = 2.0 * Z(0,0)/ (1.0 + zPow) - y[0];
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
	  double zPowM1 = pow(Z(0,0), p[1] - 1.0);
		YJAC(0,0) = -1.0;
		ZJAC(0,0,0) = 2.0 * ((1.0 + zPow) - zPowM1) / ((1.0 + zPow) * (1.0 + zPow));

		PJAC(0,0) = 0.0;
		PJAC(0,1) = - 2.0 * Z(0,0) * log(Z(0,0)) * zPow / ((1.0 + zPow) * (1.0 + zPow));;
		PJAC(0,2) = 0.0;
	}
}
/*---------------------------------------------*/
void historyFunc_08(int historySegmentIndex,
											 double t,
                       int l, double* p,
                       int m, double* h,
                       ddemUserProvidedJac* userProvidedJac,
											 void* comm)
{
  h[0] = p[2];
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;

		PJAC(0,0) = 0.0;
		PJAC(0,1) = 0.0;
		PJAC(0,2) = 1.0;

		if(userProvidedJac->needed2nd)
		{
			userProvidedJac->ttIndependent = DDEM_TRUE;
			userProvidedJac->tpIndependent = DDEM_TRUE;
		}
	}
}
/*---------------------------------------------*/
void delayArgumentsFunc_08(double t, int m, double* y,
                                   int l, double* p,
                                   int nu, int omega, double* alpha,
                                   ddemUserProvidedJac* userProvidedJac,
																	 void* comm)
{
  alpha[0] = t - p[0];
	if(userProvidedJac->needed)
	{
		TJAC(0) = 1.0;
		userProvidedJac->yIndependent = DDEM_TRUE;
		PJAC(0,0) = -1.0;
		PJAC(0,1) = 0.0;
		PJAC(0,2) = 0.0;
	}
}
/*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/
void getSystem_08(ddemSystem* system)
{
	system->create(1, 3, 1, 0);

	system->setF(f_08);

	system->setHistory(historyFunc_08);

	system->setT0(0.0);

	system->setDelayArguments(1, 0, delayArgumentsFunc_08, DDEM_FALSE);
}
/*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/
void getSimulationA_08(double TOL, ddemSimulationAttributes* simA)
{
	simA->parameters[0] = 2.0;// + 1e-7;// tau
	simA->parameters[1] = 9.65;//n
	simA->parameters[2] = 0.5;//A

	simA->tEnd = 100.0;

	simA->relTolerance = TOL;
	simA->absTolerance[0] = TOL;
}
