#include "systems.h"
#include "system_00.h"
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
#ifndef __DDEM_INDEX_TRANSLATOR_DEF
#define __DDEM_INDEX_TRANSLATOR_DEF

#define Z(I,J) z[(J)*m + (I)]
/* Z(I,J) corresponds to y_I(alpha_J) if  0<= J < nu */
/* Z(I,J) corresponds to y'_I(alpha_J) if nu <= J < nu + omega */

#define TJAC(I) userProvidedJac->tJac[(I)]
#define YJAC(I,J) userProvidedJac->yJac[(I)*m + (J)]
#define ZJAC(I,J,K) userProvidedJac->zJac[(I)*(m*(nu+omega)) + (K)*m+(J)]
/* par F_I / par Z(J,K) */
#define PJAC(I,J) userProvidedJac->pJac[(I)*l + (J)]

#define TTJAC(I) userProvidedJac->ttJac[(I)]
#define TPJAC(I,J) userProvidedJac->tpJac[(I)*l + (J)]

#endif // __DDEM_INDEX_TRANSLATOR_DEF
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*----------UNCOMMENT, RENAME, AND USE THE REQUIRED FUNCTIONS------------*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/

void	f_09(int state, double t, int m, double* y,
										  int nu, int omega, double* z,
											int l, double* p,
											double* f,
                      ddemUserProvidedJac* userProvidedJac,
											void* comm)
{
  f[0] = - Z(0,0) ;
	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		userProvidedJac->yIndependent = DDEM_TRUE;
		ZJAC(0,0,0) = - 1.0;
		userProvidedJac->pIndependent = DDEM_TRUE;
	}
}
/*---------------------------------------------*/
void historyFunc_09(int historySegmentIndex,
											 double t,
                       int l, double* p,
                       int m, double* h,
                       ddemUserProvidedJac* userProvidedJac,
											 void* comm)
{
  h[0] = - t + p[1];
	if(userProvidedJac->needed)
	{
		TJAC(0) = -1.0;
		PJAC(0,0) = 0.0;
		PJAC(0,1) = 1.0;
		if(userProvidedJac->needed2nd)
		{
			userProvidedJac->ttIndependent = DDEM_TRUE;
			userProvidedJac->tpIndependent = DDEM_TRUE;
		}
	}
}
/*---------------------------------------------*/
void delayArgumentsFunc_09(double t, int m, double* y,
                                   int l, double* p,
                                   int nu, int omega, double* alpha,
                                   ddemUserProvidedJac* userProvidedJac,
																	 void* comm)
{
  alpha[0] = t - p[0];
	if(userProvidedJac->needed)
	{
		TJAC(0) = 1.0;
		userProvidedJac->yIndependent = DDEM_TRUE;
		PJAC(0,0) = -1.0;
		PJAC(0,1) = 0.0;
	}
}
/*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/
void getSystem_09(ddemSystem* system)
{
	system->create(1, 2, 1, 0);

	system->setF(f_09);

	system->setHistory(historyFunc_09);

	system->setT0(0.0);

	system->setDelayArguments(0, 1, delayArgumentsFunc_09, DDEM_FALSE);
}
/*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/
void getSimulationA_09(double TOL, ddemSimulationAttributes* simA)
{
	simA->parameters[0] = 0.1;
	simA->parameters[1] = 8.0;

	simA->tEnd = 0.9;

	simA->relTolerance = TOL;
	simA->absTolerance[0] = TOL;
}
