#include "systems.h"
#include "system_10.h"
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
#ifndef __DDEM_INDEX_TRANSLATOR_DEF
#define __DDEM_INDEX_TRANSLATOR_DEF

#define Z(I,J) z[(J)*m + (I)]
/* Z(I,J) corresponds to y_I(alpha_J) if  0<= J < nu */
/* Z(I,J) corresponds to y'_I(alpha_J) if nu <= J < nu + omega */

#define TJAC(I) userProvidedJac->tJac[(I)]
#define YJAC(I,J) userProvidedJac->yJac[(I)*m + (J)]
#define ZJAC(I,J,K) userProvidedJac->zJac[(I)*(m*(nu+omega)) + (K)*m+(J)]
/* par F_I / par Z(J,K) */
#define PJAC(I,J) userProvidedJac->pJac[(I)*l + (J)]

#define TTJAC(I) userProvidedJac->ttJac[(I)]
#define TPJAC(I,J) userProvidedJac->tpJac[(I)*l + (J)]

#endif // __DDEM_INDEX_TRANSLATOR_DEF
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*----------UNCOMMENT, RENAME, AND USE THE REQUIRED FUNCTIONS------------*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void	f_10(int state, double t, int m, double* y,
										  int nu, int omega, double* z,
											int l, double* p,
											double* f,
                      ddemUserProvidedJac* userProvidedJac,
											void* comm)
{
	f[0] = - y[0] * Z(1,0) + Z(1,1);
	f[1] =  y[0] * Z(1,0) - y[1];
	f[2] =	 y[1] - Z(1,1);

	if(userProvidedJac->needed)
	{
		userProvidedJac->tIndependent = DDEM_TRUE;
		YJAC(0,0) = -Z(1,0); YJAC(0,1) = 0.0;	YJAC(0,2) = 0.0;
		YJAC(1,0) = Z(1,0);	YJAC(1,1) = -1.0;	YJAC(1,2) = 0.0;
		YJAC(2,0) = 0.0;	YJAC(2,1) = 1.0;	YJAC(2,2) = 0.0;

		ZJAC(0,0,0) = 0.0; ZJAC(0,0,1) = 0.0;
		ZJAC(0,1,0) = -y[0]; ZJAC(0,1,1) = 1.0;
		ZJAC(0,2,0) = 0.0; ZJAC(0,2,1) = 0.0;

		ZJAC(1,0,0) = 0.0; ZJAC(1,0,1) = 0.0;
		ZJAC(1,1,0) = y[0]; ZJAC(1,1,1) = 0.0;
		ZJAC(1,2,0) = 0.0; ZJAC(1,2,1) = 0.0;

		ZJAC(2,0,0) = 0.0; ZJAC(2,0,1) = 0.0;
		ZJAC(2,1,0) = 0.0; ZJAC(2,1,1) = -1.0;
		ZJAC(2,2,0) = 0.0; ZJAC(2,2,1) = 0.0;
		userProvidedJac->pIndependent = DDEM_TRUE;
	}
}
/*---------------------------------------------*/
void delayArgumentsFunc_10(double t, int m, double* y,
                                   int l, double* p,
                                   int nu, int omega, double* alpha,
                                   ddemUserProvidedJac* userProvidedJac,
																	 void* comm)
{
  alpha[0] = t - p[0];
  alpha[1] = t - p[1];
	if(userProvidedJac->needed)
	{
		TJAC(0) = 1.0;
		TJAC(1) = 1.0;
		userProvidedJac->yIndependent = DDEM_TRUE;
		PJAC(0,0) = -1.0;
		PJAC(0,1) =  0.0;
		PJAC(1,0) =  0.0;
		PJAC(1,1) = -1.0;
	}
}
/*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/
void getSystem_10(ddemSystem* system)
{
	system->create(3, 2, 1, 0);

	system->setF(f_10);

	double h[]={5.0, 0.1, 1.0};
	system->setHistory(h);

	system->setT0(0.0);

	system->setDelayArguments(2, 0, delayArgumentsFunc_10, DDEM_FALSE);
}
/*&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&*/
void getSimulationA_10(double TOL, ddemSimulationAttributes* simA)
{
	simA->parameters[0] = 1.0;
	simA->parameters[1] = 10.0;

	simA->tEnd = 55.0;

	simA->relTolerance = TOL;
	simA->absTolerance[0] = TOL;
	simA->absTolerance[1] = TOL;
	simA->absTolerance[2] = TOL;
}
