#ifndef __DDEM_CONSTRAINTS
#define __DDEM_CONSTRAINTS
/************************************************************/
#include "ddem_basic_defins.h"
//#include "ddem_problem.h"
//#include "ddem_parameter_estimator.h"
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
typedef void (*ddemNonlinearConstraints)(int l,
																						 int ncnlin,
																						 int needc[], double p[], 
													                   double conf[], double cjac[],
																						 int flag);
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
class ddemConstraints{
	private:
		int created_;
	private:
    ddemNonlinearConstraints NonlinearConstraints_;
    double* linearConstraintsMatrix_;
    int nParameters_;
    int nLinearConstraints_;
    int nNonlinearConstraints_;
    int nConstraints_;
    double infinityBound_;
		double noLowerBound_;
		double noUpperBound_;

		double* lowerBounds_;
		double* upperBounds_;
		int* isFree_;
	friend class ddemParameterEstimator;
  public:
		int isFree(int parameterIndex);
    int getnNonlinearConstraints(){return nNonlinearConstraints_;};
    int create(int nParameters,/*  int nSimpleBounds, */
                    int nLinearConstraints, int nNonlinearConstraints,
                    double infinityBound);
		ddemConstraints();
   ~ddemConstraints();
    /*----------------*/
    void setSimpleLowerBound(int parameterIndex, double lowerBound);
    void setSimpleUpperBound(int parameterIndex, double upperBound);
    void setSimpleEquality(int parameterIndex, double parameterFixedValue);
    /*----------------*/
    void setLinearConstraintsMatrix(double linearConstraintsMatrix[]);
    void setLinearConstraintLowerBound(int linearConstraintIndex,
                                       double lowerBound);
    void setLinearConstraintUpperBound(int linearConstraintIndex,
                                       double upperBound);
    void setLinearConstraintEquality(int linearConstraintIndex,
                                     double equalityRightHandSide);
    /*----------------*/
    void setNonlinearConstraints(ddemNonlinearConstraints
                                       nonlinearConstraints);
    void setNonlinearConstraintLowerBound(int nonlinearConstraintIndex,
                                          double lowerBound);
    void setNonlinearConstraintUpperBound(int nonlinearConstraintIndex,
                                          double upperBound);
    void setNonlinearConstraintEquality(int nonlinearConstraintIndex,
                                        double equalityRightHandSide);
    /*----------------*/
		void computeNonlinearConstraints(int l, int needc[], double p[],
													                   double conf[], double cjac[],
																						 int flag);
};
#endif /* __DDEM_CONSTRAINTS*/
