/* DOUBLE CHECKED = YES*/
#include <iostream>
using namespace std;
#include <string>
#include <fstream>


#include "ddem_data.h"
#include "ddem_error_codes.h"
#include "ddem_trace.h"
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/************************************************************/
int ddemData::Load(string fileName)
{
	ifstream inDataFile;
	inDataFile.open( fileName.c_str(), ios::in );
	if (!inDataFile){
		cerr << "File " << fileName << " could not be opened\n";
		//exit( 1 );
		return DDEM_FAILURE;
	}else if(DDEM_TRACE_DATA)
			cout << "File " << fileName << " was opened successfully.\n";
	inDataFile >> nGammas_;
	if(!inDataFile.good()){
		cerr << "File could not be read\n";
		//exit( 1 );
		inDataFile.close();
		return DDEM_FAILURE;
	}
	/*-----------------------*/
  gammas_ = new double[nGammas_];
	invertGammaIndicesFirst_ = new int[nGammas_];
	invertGammaIndicesLast_ = new int[nGammas_];
	/*-----------------------*/
	inDataFile >> nYs_;
	if(!inDataFile.good()){
		cerr << "File could not be read\n";
		inDataFile.close();
		return DDEM_FAILURE;
		//exit( 1 );
	}
	/*-----------------------*/
  gammasIndices_ = new int[nYs_];
  YsIndices_ = new int[nYs_];
  Ys_ = new double[nYs_];
	/*-----------------------*/
	int currentYIndex = 0;
	for(int i=0; i < nGammas_; i++){
		invertGammaIndicesFirst_[i] = currentYIndex;
		inDataFile >> gammas_[i];
		int nYsForGamma_i;
		inDataFile >> nYsForGamma_i;
		for(int j=0; j < nYsForGamma_i; j++){
			if(currentYIndex >= nYs_){
				cerr << "More data provided than declared\n";
				inDataFile.close();
				return DDEM_FAILURE;
				//exit( 1 );
			}
			gammasIndices_[currentYIndex] = i;
			inDataFile >> YsIndices_[currentYIndex];
			YsIndices_[currentYIndex] -= 1;
			inDataFile >> Ys_[currentYIndex];
			currentYIndex += 1;
		}
		invertGammaIndicesLast_[i] = currentYIndex - 1;
	}
	inDataFile.close();
	return DDEM_SUCCESS;
}
/************************************************************/
ddemData::ddemData()
{
	gammas_ = NULL;
	gammasIndices_ = NULL;
	YsIndices_ = NULL;
	Ys_ = NULL;
	invertGammaIndicesFirst_ = NULL;
	invertGammaIndicesLast_ = NULL;
}
ddemData::~ddemData()
{
	if(gammas_ != NULL){delete gammas_; gammas_ = NULL;}
	if(gammasIndices_ != NULL){delete gammasIndices_; gammasIndices_ = NULL;}
	if(YsIndices_ != NULL){delete YsIndices_; YsIndices_ = NULL;}
	if(Ys_ != NULL){delete Ys_; Ys_ = NULL;}
	if(invertGammaIndicesFirst_ != NULL){delete invertGammaIndicesFirst_; invertGammaIndicesFirst_ = NULL;}
	if(invertGammaIndicesLast_ != NULL){delete invertGammaIndicesLast_; invertGammaIndicesLast_ = NULL;}
}


