#ifndef __DDEM_ERROR_CODES
#define __DDEM_ERROR_CODES
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
#define DDEM_SUCCESS 0
#define DDEM_FAILURE -1

#define DDEM_ERR_BASE																	(-50)
#define DDEM_ERR_UNEXPECTED														(DDEM_ERR_BASE - 1)

/*SIMULATOR*/
#define DDEM_ERR_SIM_BASE															(-100)
#define DDEM_ERR_SIM_MAX_MESH_POINTS_REACHED					(DDEM_ERR_SIM_BASE - 1)
#define DDEM_ERR_SIM_MAX_DISC_POINTS_REACHED					(DDEM_ERR_SIM_BASE - 2)
#define DDEM_ERR_SIM_ADV_OR_VANISHING_DELAY						(DDEM_ERR_SIM_BASE - 3)

#define DDEM_ERR_SIM_T_LESS_THAN_T0										(DDEM_ERR_SIM_BASE - 4)
#define DDEM_ERR_SIM_T_GREATER_THAN_TLAST							(DDEM_ERR_SIM_BASE - 5)

#define DDEM_ERR_SIM_LAMBDA_INDEX_OUT_OF_RANGE				(DDEM_ERR_SIM_BASE - 6)
#define DDEM_ERR_SIM_MESH_POINT_INDEX_OUT_OF_RANGE		(DDEM_ERR_SIM_BASE - 7)

#define DDEM_ERR_SIM_REQUIRED_EXTENSION_IS_IMPOSSIBLE	(DDEM_ERR_SIM_BASE - 7)
#define DDEM_ERR_SIM_CALL_DENIED											(DDEM_ERR_SIM_BASE - 8)

#define DDEM_ERR_SIM_VANISHING_ITER_CANNOT_CONVERGE		(DDEM_ERR_SIM_BASE - 9)

/*SYSTEM*/
#define DDEM_ERR_SYS_BASE														(-200)
#define DDEM_ERR_SYS_INVALID_HISTORY_SEGMENT_INDEX		(DDEM_ERR_SYS_BASE - 1)

/*MIN_ROOT*/
#define DDEM_ERR_MINROOT_BASE													(-300)
#define DDEM_ERR_MINROOT_NO_ROOTS_WERE_FOUND					(DDEM_ERR_MINROOT_BASE - 4)

/*SENSITIVITY_ANALYZER*/
#define DDEM_ERR_SENS_BASE														(-400)
#define DDEM_ERR_SENS_VANISHING_DENOMINATOR						(DDEM_ERR_SENS_BASE - 1)
#define DDEM_ERR_SENS_DATA_OUT_OF_RANGE								(DDEM_ERR_SENS_BASE - 2)

/*PARAMETER_ESTIMATOR*/
#define DDEM_ERR_PARAMEST_BASE												(-500)
#define DDEM_ERR_PARAMEST_MAX_ITER_REACHED						(DDEM_ERR_PARAMEST_BASE - 1)


/*NAG*/
#define DDEM_ERR_NAG_BASE															(-1000)

/*IVP2DDE*/
#define DDEM_ERR_IVP2DDE_BASE													(-2000)

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
#endif /*__DDEM_ERROR_CODES*/
