#ifndef  __DDEM_FSENS_SYSTEM
#define  __DDEM_FSENS_SYSTEM

#include "ddem_system.h"

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
class ddemFSensSystem: public ddemSystemInterface{
	ddemSystem* baseSystem_;
	int nS_; /* number of required sensitivities*/;
	int* sIndices_;/*indices of required sensitivities*/
public:
		ddemFSensSystem(ddemSystem* baseSystem, int nS, int* sIndices);
    ~ddemFSensSystem();
		virtual int getNVariables();
    virtual int getNParameters();
		virtual int getNHistorySegments();
		virtual int getNu();
		virtual int getOmega();
		virtual int evalF(double t, double* y,
										 double* z,
										 double* p,
										 double* f,
										 void* comm);
		int evalPartialsDelayArgumentsBaseSystem(double t, double* y,
																		double* p,
																		int selIndex,
																		double& parAlphaSelParT,
																		double* parAlphaSelParY,
																		double* parAlphaSelParP,
																		void* comm);
		int getNSelectedParameters();
		virtual int evalDelayArguments(double t, double* y,
																		double* p,
																		double* alpha,
																		void* comm);
		virtual int evalHistoryStart(int historySegmentIndex,
																	double*p,
																	double& historyStart,
																	void* comm);
		virtual int getHistoryStartDiscDegree(int historySegmentIndex,
																	int& historyStartDiscDegree,
																	void* comm);
		int evalPartialsHistoryStart(int historySegmentIndex,
																	double*p,
																	double* partialsHistoryStart,
																	void* comm);
    virtual int evalDerivHistory(int historySegmentIndex,
																		double t,
                                    double* p,
                                    double* h,
																	  void* comm);
    virtual int evalHistory(int historySegmentIndex,
																		double t,
                                    double* p,
                                    double* h,
																	  void* comm);
		virtual int compT0(double* p,
               double& t0,
							void* comm);
		int compPartialsT0(double* p,
               double* partialsT0,
							void* comm);
		virtual int compT0DiscDegree(double* p,
               int& t0DiscDegree,
							void* comm);
		virtual int compY0(double* p,
               double* y0,
							 double* historyStarts,
							 void* comm);
		virtual int locateBetweenHistoryStarts(double t,
																						double* historyStarts,
																						int& betweenHisroryIndex);

		virtual int getContReductionFactor(){return 1;};
		virtual int getContPropagFactor(int delayArgumentIndex){
			if(delayArgumentIndex < baseSystem_->getNu())
				return 1;
			else if(delayArgumentIndex < baseSystem_->getNu()
																	+ baseSystem_->getOmega())
				return 0;
			else
				return 1;
		}
		virtual int stateDependent(){
			return baseSystem_->stateDependent();
		}
private:
		void pJac2SensOfVar_(double* pJac, double* var);
		void tJac2XOfVar_(double* tJac, double* var);
		virtual void createUserProvidedJacs_();
		virtual void destroyUserProvidedJacs_();
};
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void needSensitivity2Indices(int nParameters, int* needSensitivity,
														 int* sIndices, int& nS);

/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
#endif /* __DDEM_FSENS_SYSTEM*/
