/* DOUBLE CHECKED = YES*/
#include <iostream>
using namespace std;
#include <fstream>
#include <iomanip>
#include <string>

#include "ddem_sens_out.h"
#include "ddem_sol_out.h"

#include "ddem_error_codes.h"
#include "ddem_trace.h"
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
int ddemOutSensUniform(ddemSensitivitySolution* sensitivitySolution,
												int yIndex,
												int parameterIndex,
												int interpSelect,
												int nOutPoints,
												string fileName,
												int precision,
												ddemSimulator* simulator)
{
	int whichInSelection = sensitivitySolution->getParameterPlaceInSelection(parameterIndex);
	if(whichInSelection != DDEM_UNDEFINED){
		int outYIndex = (sensitivitySolution->getParameterPlaceInSelection(parameterIndex) + 1)
										* sensitivitySolution->getNVariablesBase() +  yIndex;
		return
			ddemOutSolUniform(sensitivitySolution,
											outYIndex,
											interpSelect,
											nOutPoints,
											fileName,
											precision,
											simulator);
	}else
		return DDEM_FAILURE;
}
/************************************************************/
int ddemOutSensUniformAll(ddemSensitivitySolution* sensitivitySolution,
												int interpSelect,
												int nOutPoints,
												string fileName,
												int precision,
												ddemSimulator* simulator)
{
	return
		ddemOutSolUniformAll(sensitivitySolution,
											interpSelect,
											nOutPoints,
											fileName,
											precision,
											simulator);
}
/************************************************************/
int ddemOutSensFDUniform(ddemSensitivitySolutionFD* sensitivitySolutionFD,
												int yIndex,
												int parameterIndex,
												string fileName,
												int precision)
{
	int whichInSelection = sensitivitySolutionFD->getParameterPlaceInSelection(parameterIndex);
	if(whichInSelection != DDEM_UNDEFINED){
		int outYIndex = (sensitivitySolutionFD->getParameterPlaceInSelection(parameterIndex) + 1)
										* sensitivitySolutionFD->getNVariablesBase() +  yIndex;

		ofstream outSolFile;
		outSolFile.open(fileName.c_str(), ios::out );
		if (!outSolFile){
			cerr << "File " << fileName << " could not be opened\n";
			return DDEM_FAILURE;
		}
		outSolFile <<  setiosflags( ios::scientific | ios::showpoint ) << setprecision(precision);

		for(int i=0; i < sensitivitySolutionFD->getNPoints(); i++){
				outSolFile << sensitivitySolutionFD->ts[i] << "  " << sensitivitySolutionFD->ys[i][outYIndex] << endl;
		}

		outSolFile.close();
		return DDEM_SUCCESS;

	}else
		return DDEM_FAILURE;
}
/************************************************************/
int ddemOutSensFDUniformAll(ddemSensitivitySolutionFD* sensitivitySolutionFD,
												int yIndex,
												int parameterIndex,
												string fileName,
												int precision)
{
	ofstream outSolFile;
	outSolFile.open(fileName.c_str(), ios::out );
	if (!outSolFile){
		cerr << "File " << fileName << " could not be opened\n";
		return DDEM_FAILURE;
	}
	outSolFile <<  setiosflags( ios::scientific | ios::showpoint ) << setprecision(precision);

	for(int i=0; i < sensitivitySolutionFD->getNPoints(); i++){
		outSolFile << sensitivitySolutionFD->ts[i]; 
		for(int outYIndex = 0; outYIndex < sensitivitySolutionFD->getNVariables(); outYIndex++)
			outSolFile << "  " << sensitivitySolutionFD->ys[i][outYIndex];
		outSolFile << endl;
	}
	outSolFile.close();
	return DDEM_SUCCESS;
}
/************************************************************/
int ddemOutSensNonUniform(ddemSensitivitySolution* sensitivitySolution,
											int yIndex,
											int parameterIndex,
											int interpSelect,
											int nOutPoints,
											string fileName,
											string fileNameDisc,
											int precision,
											ddemSimulator* simulator)
{
	int whichInSelection = sensitivitySolution->getParameterPlaceInSelection(parameterIndex);
	if(whichInSelection != DDEM_UNDEFINED){
		int outYIndex = (sensitivitySolution->getParameterPlaceInSelection(parameterIndex) + 1)
										* sensitivitySolution->getNVariablesBase() +  yIndex;
		return
			ddemOutSolNonUniform(sensitivitySolution,
											outYIndex,
											interpSelect,
											nOutPoints,
											fileName,
											fileNameDisc,
											precision,
											simulator);
	}else
		return DDEM_FAILURE;
}
/************************************************************/
int ddemOutSensNonUniformAll(ddemSensitivitySolution* sensitivitySolution,
											int interpSelect,
											int nOutPoints,
											string fileName,
											string fileNameDisc,
											int precision,
											ddemSimulator* simulator)
{
	return
		ddemOutSolNonUniformAll(sensitivitySolution,
											interpSelect,
											nOutPoints,
											fileName,
											fileNameDisc,
											precision,
											simulator);
}
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
