#ifndef __DDEM_SENSITIVITY_ANALYZER
#define __DDEM_SENSITIVITY_ANALYZER
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
#include "ddem_simulator.h"
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
struct ddemSensParameterSelector{
		ddemSensParameterSelector();
	 ~ddemSensParameterSelector();

	  int setNVariablesBase(int nVariablesBase);
		int getNVariablesBase();
		int setParametersPlacesInSelection(int nParameters, int nS, int* sIndices);
		int getParameterPlaceInSelection(int parameterIndex);

protected:
	int nVariablesBase_;
	int* selParametersRevIndices_;
	int nParameters_;
};
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
struct ddemSensitivitySolution: public ddemSimulationSolution,
																public ddemSensParameterSelector{

    double** lambdasJac;
    /*****************************************/
		ddemSensitivitySolution();
	 ~ddemSensitivitySolution();
	 	void allocateExtraMemories(int nSelectedParameters,
															int nHistorySegments);
		void releaseExtraMemories();

		int isAllocatedExtra();
		/******************/
		double**	historyStartsLambdasJac;
		/******************/
private:
		int isAllocatedExtra_;
};
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
struct ddemSensitivitySolutionFD: public ddemSensParameterSelector{
		double* ts;
		double** ys;
    /*****************************************/
		ddemSensitivitySolutionFD();
	 ~ddemSensitivitySolutionFD();
		int allocateMemories(int nVariablesBase, int nS, int nPoints);
		int getNPoints(){ return nPoints_;};
		int getNVariables(){return (1+nS_) * nVariablesBase_;};
private:
		int isAllocated_;
		int releaseMemories_();
		int nPoints_;
		int nS_;
};
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
class ddemSensitivityAnalyzer{
		/*ddemSimulator* simulator_;*/  
public:
    ddemSensitivityAnalyzer();
   ~ddemSensitivityAnalyzer();
    int computeSensitivities(ddemSimulator* simulator,
															ddemSystem* System, double tEnd,
                              double* parameters,
															double relToleranceBase,
															double* absToleranceBase,
															double vanishingConst,
															int needSensitivity[],
															void* commWithUFuncs,
                              ddemSensitivitySolution* sensitivitySolution);
    int computeSensitivitiesFD(ddemSimulator* simulator,
															ddemSystem* System, double tEnd,
                              double* parameters,
															double deltaP,
															double relToleranceBase,
															double* absToleranceBase,
															double vanishingConst,
															int needSensitivity[],
															int nOutPoints,
															void* commWithUFuncs,
                              ddemSensitivitySolutionFD* sensitivitySolutionFD);
private:
		int compZBaseSystemAtDisc_(double* parameters,
																ddemSimulator* simulator,
																ddemSystem* baseSystem,
																int sensNVariables,
																ddemViolation* violated,
																ddemSimulationSolution* simulationSolution,
																double* zBaseSystem,
																void* commWithUFuncs);
		int initializeIndices_(ddemSystem* baseSystem,
													int needSensitivity[],
													int& nS,
													int*& sIndices,
													ddemSensParameterSelector* sensParameterSelector);
};
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
void needSensitivity2Indices(int nParameters, int* needSensitivity,
														 int* sIndices, int& nS);
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
/*XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX*/
#endif /* __DDEM_SENSITIVITY_ANALYZER*/
