/* Improved_CRK.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/
/* Common Block Declarations */

/*struct {
    int int__;
} err_;*/
//extern "C" {
#include "ddem_f2c_indep.h"
//}

#define err_1 err_

/* Table of constant values */

static double c_b33 = .16666666666666666;
static double c_b39 = 0.;
static int c__0 = 0;
static int c__1 = 1;


/*  This is an experimental implementation of the order 6 explicit */
/*  continuous RK method with defect control discussed and analyzed */
/*  In Hayes and Enright, TOMS 2006, and in Enright (CAIMS lecture */
/*  July, 2006). The parameters and calling sequence are consistent */
/*  with those of the DVERK family of RK methods developed at Toronto */
/*  over the last two decades. The principle focus of this version */
/*  is the investigation of reliable defect control schemes. */
/*  Note that this version uses an interpolant of degree 7 and abscissa */
/*  vector [.07, .14, .86, .93] when invoked with INT equal 2 or 3. */


/*  The particular interpolant and defect estimating strategy is */
/*  selected by setting the global variable INT in the driver using */
/*  labled common (common/Err/ Int). There are currently four */
/*  possible values for this parameter (INT = 0,1,2,3) and these */
/*  are discussed below and in the references cited above. */

/*  Note that testing has only been performed using pure absolute error */
/*  control (C(1) = 1) in the call to the integrator. (The other optional */
/*  error measures should be used with caution.) For this version the */
/*  workspace W, that is supplied must be at least W(51,20). If problems */
/*  with n > 51 are to be solved, W and a few temporary vectors will */
/*  have to have their declarations adjusted appropriately. */

/*  When the integrator returns every step (to provide the local */
/*  interpolant and other information) to the calling program, (C(9) = 1), */
/*  the trial value of y(x_i + h) is stored in the 13th column of W, */
/*  W(*,13) and y'_{i+1} is stored in W(*,9). */

/* Subroutine */ int rkd56_(n, fcn, x, y, xend, tol, ind, c__, nw, w,
														interp_Flag, ivp2ddeCommVoid)
int *n;
/* Subroutine */ int (*fcn) ();
double *x, *y, *xend, *tol;
int *ind;
double *c__;
int *nw;
double *w;
int interp_Flag;
void* ivp2ddeCommVoid;
{
    /* Format strings */
     char fmt_505[] = "(///\0020\002,\002computation stopped in rkd56 \
with the following values -  \002/\0020\002,\002ind =\002,i4,5x,\002tol  \
=\002,1pd13.6,5x,\002x         =\002,1pd22.15/\002 \002,\002n   =\002,i4,5x\
,\002hmin =\002,1pd13.6,5x,\002xend      =\002,1pd22.15/\002 \002,\002nw  \
=\002,i4,5x,\002hmax =\002,1pd13.6,5x,\002prev xend =\002,1pd22.15/\0020\002\
,14x,\002no of successful steps  =  \002,0pf8.0/\002 \002,14x,\002no of succ\
essive failures =\002,0pf8.0/\002 \002,14x,\002no of function evals  =   \
 \002,0pf8.0/\0020\002,\002the components of y are\002//(\002 \002,1p5d24.15\
))";

    /* System generated locals */
    int w_dim1, w_offset, i__1;
    double d__1, d__2, d__3, d__4, d__5, d__6;

    /* Builtin functions */
    double ddem_ddem_pow_dd(), ddem_d_sign();
    int s_wsfe(), do_fio(), e_wsfe();
    /* Subroutine */ int ddem_s_stop();

    /* Local variables */
     double temp;
     int k;
     double r1, r2, dm;
    extern /* Subroutine */ int defect_(), apform_();
     double tmp[51], tmp2, tmp3[51];

    /* Fortran I/O blocks */
    /*static cilist io___9 = { 0, 6, 0, fmt_505, 0 };*/



/* The interpolant and error control scheme is determined by the value of 
the*/
/* global flag Int. The justification and cost of each scheme is discussed
*/
/* in Hayes and Enright (2006) for INT = 0 and INT = 1; and in Enright (20
06)*/
/*  for INT = 2 and INT =3. */

/*  Int = 0 selects the standard interpolant, Int=1 the improved */
/*  and Int=2 the new improved interpolant. The latter two choices require
 */
/*  3 ( for Int = 1 ) and 4 ( for Int = 2 ) */
/*  extra derivative evaluations per step but have an easily computed */
/*  asymptotically correct estimate for the max defect on each step. */
/*  Int = 3 selects the new improved interpolant with a validity check */
/*  which involves 2 extra derivative evaluations on each step */
/*  to verify that the defect is being reliably estimated. If the */
/*  check fails then an additional 2 evaluations are performed to */
/*  estimate the max defect on the step. */


    /* Parameter adjustments */
    --y;
    --c__;
    w_dim1 = *nw;
    w_offset = w_dim1 + 1;
    w -= w_offset;

    /* Function Body */
    if (*ind < 1 || *ind > 6) {
	goto L500;
    }
    switch ((int)*ind) {
	case 1:  goto L5;
	case 2:  goto L5;
	case 3:  goto L45;
	case 4:  goto L1111;
	case 5:  goto L2222;
	case 6:  goto L2222;
    }
L5:
    if (*n > *nw || *tol <= 0.) {
	goto L500;
    }
    if (*ind == 2) {
	goto L15;
    }
    for (k = 1; k <= 9; ++k) {
	c__[k] = 0.;
/* L10: */
    }
    goto L35;
L15:
    for (k = 1; k <= 9; ++k) {
	c__[k] = (d__1 = c__[k], ddem_abs(d__1));
/* L20: */
    }
    if (c__[1] != 4. && c__[1] != 5.) {
	goto L30;
    }
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
	c__[k + 30] = (d__1 = c__[k + 30], ddem_abs(d__1));
/* L25: */
    }
L30:
L35:
    c__[10] = 1.3877787807814457e-17;
    c__[11] = 1e-35;
    c__[20] = *x;
    for (k = 21; k <= 24; ++k) {
	c__[k] = 0.;
/* L40: */
    }
    goto L50;
L45:
    if (c__[21] != 0. && (*x != c__[20] || *xend == c__[20])) {
	goto L500;
    }
    c__[21] = 0.;
    goto L50;
L50:
L99999:
    if (c__[7] == 0. || c__[24] < c__[7]) {
	goto L100;
    }
    *ind = -1;
    return 0;
L100:
    if (*ind == 6) {
	goto L105;
    }
    if (*ind == 5) {
	i__1 = *n;
	for (k = 1; k <= i__1; ++k) {
	    w[k + w_dim1] = w[k + w_dim1 * 9];
/* L102: */
	}
    } else {
	(*fcn)(n, x, &y[1], &w[w_dim1 + 1], ivp2ddeCommVoid);
	++c__[24];
    }
L105:
    c__[13] = c__[3];
    if (c__[3] != 0.) {
	goto L165;
    }
    temp = 0.;
    if (c__[1] != 1.) {
	goto L115;
    }
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
/* Computing MAX */
	d__2 = temp, d__3 = (d__1 = y[k], ddem_abs(d__1));
	temp = ddem_max(d__2,d__3);
/* L110: */
    }
    c__[12] = temp;
    goto L160;
L115:
    if (c__[1] != 2.) {
	goto L120;
    }
    c__[12] = 1.;
    goto L160;
L120:
    if (c__[1] != 3.) {
	goto L130;
    }
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
/* Computing MAX */
	d__2 = temp, d__3 = (d__1 = y[k], ddem_abs(d__1)) / c__[2];
	temp = ddem_max(d__2,d__3);
/* L125: */
    }
    c__[12] = ddem_min(temp,1.);
    goto L160;
L130:
    if (c__[1] != 4.) {
	goto L140;
    }
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
/* Computing MAX */
	d__2 = temp, d__3 = (d__1 = y[k], ddem_abs(d__1)) / c__[k + 30];
	temp = ddem_max(d__2,d__3);
/* L135: */
    }
    c__[12] = ddem_min(temp,1.);
    goto L160;
L140:
    if (c__[1] != 5.) {
	goto L150;
    }
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
/* Computing MAX */
	d__2 = temp, d__3 = (d__1 = y[k], ddem_abs(d__1)) / c__[k + 30];
	temp = ddem_max(d__2,d__3);
/* L145: */
    }
    c__[12] = temp;
    goto L160;
L150:
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
/* Computing MAX */
	d__2 = temp, d__3 = (d__1 = y[k], ddem_abs(d__1));
	temp = ddem_max(d__2,d__3);
/* L155: */
    }
    c__[12] = ddem_min(temp,1.);
L160:
/* Computing MAX */
/* Computing MAX */
    d__3 = c__[12] / *tol, d__4 = ddem_abs(*x);
    d__1 = c__[11], d__2 = c__[10] * ddem_max(d__3,d__4);
    c__[13] = ddem_max(d__1,d__2) * 10.;
L165:
    c__[15] = c__[5];
    if (c__[5] == 0.) {
	c__[15] = 1.;
    }
    if (c__[6] != 0. && c__[5] != 0.) {
/* Computing MIN */
	d__1 = c__[6], d__2 = 2. / c__[5];
	c__[16] = ddem_min(d__1,d__2);
    }
    if (c__[6] != 0. && c__[5] == 0.) {
	c__[16] = c__[6];
    }
    if (c__[6] == 0. && c__[5] != 0.) {
	c__[16] = 2. / c__[5];
    }
    if (c__[6] == 0. && c__[5] == 0.) {
	c__[16] = 2.;
    }
    if (c__[13] <= c__[16]) {
	goto L170;
    }
    *ind = -2;
    return 0;
L170:
    if (*ind > 2) {
	goto L175;
    }
    c__[14] = c__[4];
    if (c__[4] == 0.) {
	c__[14] = c__[16] * ddem_pow_dd(tol, &c_b33);
    }
    goto L185;
L175:
    if (c__[23] > 1.) {
	goto L180;
    }
    temp = c__[14] * 2.;
    if (*tol < c__[19] * 120.42729108217097) {
	d__1 = *tol / c__[19];
	temp = ddem_pow_dd(&d__1, &c_b33) * .9 * c__[14];
    }
/* Computing MAX */
    d__1 = temp, d__2 = c__[14] * .5;
    c__[14] = ddem_max(d__1,d__2);
    goto L185;
L180:
    c__[14] *= .5;
L185:
    c__[14] = ddem_min(c__[14],c__[16]);
    c__[14] = ddem_max(c__[14],c__[13]);
    if (c__[8] == 0.) {
	goto L1111;
    }
    *ind = 4;
    return 0;
L1111:
    if (c__[14] >= (d__1 = *xend - *x, ddem_abs(d__1))) {
	goto L190;
    }
/* Computing MIN */
    d__2 = c__[14], d__3 = (d__1 = *xend - *x, ddem_abs(d__1)) * .5;
    c__[14] = ddem_min(d__2,d__3);
    d__1 = *xend - *x;
    c__[17] = *x + ddem_d_sign(&c__[14], &d__1);
    goto L195;
L190:
    c__[14] = (d__1 = *xend - *x, ddem_abs(d__1));
    c__[17] = *xend;
L195:
    c__[18] = c__[17] - *x;
    apform_(n, fcn, x, &y[1], &c__[18], &w[w_offset], nw, &c_b39, &c_b39, &
	    c_b39, &c__0, interp_Flag, ivp2ddeCommVoid);
    c__[24] += 10.;
    if (interp_Flag != 0) {
	c__[24] += 3;
    }
/*           temp = .1943d0 */
    temp = .1509;
    if (interp_Flag >= 2) {
	temp = .5;
    }
    defect_(n, fcn, x, &y[1], &c__[18], &temp, &w[w_dim1 * 14 + 1], &w[(
	    w_dim1 << 1) + 1], nw, &w[w_offset], interp_Flag, ivp2ddeCommVoid);
    c__[24] += 1.;
    temp = 0.;
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
/* Computing MAX */
	d__2 = temp, d__3 = (d__1 = w[k + (w_dim1 << 1)], ddem_abs(d__1));
	temp = ddem_max(d__2,d__3);
/* L199: */
    }


    if (interp_Flag == 3) {
	tmp2 = .311;
	defect_(n, fcn, x, &y[1], &c__[18], &tmp2, tmp, tmp3, nw, &w[w_offset]
		, interp_Flag, ivp2ddeCommVoid);
	tmp2 = 0.;
	i__1 = *n;
	for (k = 1; k <= i__1; ++k) {
/* Computing MAX */
	    d__2 = tmp2, d__3 = (d__1 = tmp3[k - 1], ddem_abs(d__1));
	    tmp2 = ddem_max(d__2,d__3);
/* L201: */
	}
	r1 = tmp2 / temp;


	if (r1 > 1.) {
	    i__1 = *n;
	    for (k = 1; k <= i__1; ++k) {
		w[k + (w_dim1 << 1)] = tmp3[k - 1];
/* L301: */
	    }
	}
	tmp2 = .689;
	defect_(n, fcn, x, &y[1], &c__[18], &tmp2, tmp, tmp3, nw, &w[w_offset]
		, interp_Flag, ivp2ddeCommVoid);
	tmp2 = 0.;
	i__1 = *n;
	for (k = 1; k <= i__1; ++k) {
/* Computing MAX */
	    d__2 = tmp2, d__3 = (d__1 = tmp3[k - 1], ddem_abs(d__1));
	    tmp2 = ddem_max(d__2,d__3);
/* L202: */
	}
	r2 = tmp2 / temp;
	if (r2 > ddem_max(r1,1.)) {
	    i__1 = *n;
	    for (k = 1; k <= i__1; ++k) {
		w[k + (w_dim1 << 1)] = tmp3[k - 1];
/* L302: */
	    }
	}
	c__[24] += 2;
/* Computing MAX */
	d__3 = (d__1 = r1 - .5, ddem_abs(d__1)), d__4 = (d__2 = r2 - .5, ddem_abs(d__2))
		;
	if (ddem_max(d__3,d__4) > .2) {
/* Computing MAX */
	    d__1 = 1., d__2 = ddem_max(r1,r2);
	    dm = temp * ddem_max(d__1,d__2);
	    tmp2 = .373;
	    defect_(n, fcn, x, &y[1], &c__[18], &tmp2, tmp, tmp3, nw, &w[
		    w_offset], interp_Flag, ivp2ddeCommVoid);
	    tmp2 = 0.;
	    i__1 = *n;
	    for (k = 1; k <= i__1; ++k) {
/* Computing MAX */
		d__2 = tmp2, d__3 = (d__1 = tmp3[k - 1], ddem_abs(d__1));
		tmp2 = ddem_max(d__2,d__3);
/* L203: */
	    }
	    if (tmp2 > dm) {
		i__1 = *n;
		for (k = 1; k <= i__1; ++k) {
		    w[k + (w_dim1 << 1)] = tmp3[k - 1];
/* L303: */
		}
	    }
	    dm = ddem_max(dm,tmp2);
	    tmp2 = .626;
	    defect_(n, fcn, x, &y[1], &c__[18], &tmp2, tmp, tmp3, nw, &w[
		    w_offset], interp_Flag, ivp2ddeCommVoid);
	    tmp2 = 0.;
	    i__1 = *n;
	    for (k = 1; k <= i__1; ++k) {
/* Computing MAX */
		d__2 = tmp2, d__3 = (d__1 = tmp3[k - 1], ddem_abs(d__1));
		tmp2 = ddem_max(d__2,d__3);
/* L204: */
	    }
	    if (tmp2 > dm) {
		i__1 = *n;
		for (k = 1; k <= i__1; ++k) {
		    w[k + (w_dim1 << 1)] = tmp3[k - 1];
/* L304: */
		}
	    }
	    dm = ddem_max(dm,tmp2);
	    temp = dm;
	    c__[24] += 2;
	}
    }
    temp = 0.;
    if (c__[1] != 1.) {
	goto L310;
    }
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
/* Computing MAX */
	d__2 = temp, d__3 = (d__1 = w[k + (w_dim1 << 1)], ddem_abs(d__1));
	temp = ddem_max(d__2,d__3);
/* L305: */
    }
    goto L360;
L310:
    if (c__[1] != 2.) {
	goto L320;
    }
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
/* Computing MAX */
	d__2 = temp, d__3 = (d__1 = w[k + (w_dim1 << 1)] / w[k + w_dim1], ddem_abs(
		d__1));
	temp = ddem_max(d__2,d__3);
/* L315: */
    }
    goto L360;
L320:
    if (c__[1] != 3.) {
	goto L330;
    }
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
/* Computing MAX */
/* Computing MAX */
	d__5 = c__[2], d__6 = (d__2 = w[k + w_dim1], ddem_abs(d__2));
	d__3 = temp, d__4 = (d__1 = w[k + (w_dim1 << 1)], ddem_abs(d__1)) / ddem_max(
		d__5,d__6);
	temp = ddem_max(d__3,d__4);
/* L325: */
    }
    goto L360;
L330:
    if (c__[1] != 4.) {
	goto L340;
    }
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
/* Computing MAX */
/* Computing MAX */
	d__5 = c__[k + 30], d__6 = (d__2 = w[k + w_dim1], ddem_abs(d__2));
	d__3 = temp, d__4 = (d__1 = w[k + (w_dim1 << 1)], ddem_abs(d__1)) / ddem_max(
		d__5,d__6);
	temp = ddem_max(d__3,d__4);
/* L335: */
    }
    goto L360;
L340:
    if (c__[1] != 5.) {
	goto L350;
    }
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
/* Computing MAX */
	d__2 = temp, d__3 = (d__1 = w[k + (w_dim1 << 1)] / c__[k + 30], ddem_abs(
		d__1));
	temp = ddem_max(d__2,d__3);
/* L345: */
    }
    goto L360;
L350:
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
/* Computing MAX */
/* Computing MAX */
	d__5 = 1., d__6 = (d__2 = w[k + w_dim1], ddem_abs(d__2));
	d__3 = temp, d__4 = (d__1 = w[k + (w_dim1 << 1)], ddem_abs(d__1)) / ddem_max(
		d__5,d__6);
	temp = ddem_max(d__3,d__4);
/* L355: */
    }
L360:
    c__[19] = temp;
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
	w[k + w_dim1 * 14] = y[k];
/* L390: */
    }
    *ind = 5;
    if (c__[19] > *tol) {
	*ind = 6;
    }
    if (c__[9] == 0.) {
	goto L2222;
    }
    return 0;
L2222:
    if (*ind == 6) {
	goto L410;
    }
    *x = c__[17];
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
	y[k] = w[k + w_dim1 * 13];
/* L400: */
    }
    c__[22] += 1.;
    c__[23] = 0.;
    if (*x != *xend) {
	goto L405;
    }
    *ind = 3;
    c__[20] = *xend;
    c__[21] = 1.;
    return 0;
L405:
    goto L420;
L410:
    c__[23] += 1.;
    if (c__[14] > c__[13]) {
	goto L415;
    }
    *ind = -3;
    return 0;
L415:
L420:
    goto L99999;
L500:
    /*s_wsfe(&io___9);
    do_fio(&c__1, (char *)&(*ind), (ftnlen)sizeof(int));
    do_fio(&c__1, (char *)&(*tol), (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&(*x), (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&(*n), (ftnlen)sizeof(int));
    do_fio(&c__1, (char *)&c__[13], (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&(*xend), (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&(*nw), (ftnlen)sizeof(int));
    do_fio(&c__1, (char *)&c__[16], (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&c__[20], (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&c__[22], (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&c__[23], (ftnlen)sizeof(double));
    do_fio(&c__1, (char *)&c__[24], (ftnlen)sizeof(double));
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
	do_fio(&c__1, (char *)&y[k], (ftnlen)sizeof(double));
    }
    e_wsfe();*//*by hzp*/
    ddem_s_stop("", 0L);
		return -1;
} /* rkd56_ */

/* Subroutine */ int apform_(n, fcn, x, y, h__, w, nw, aa, bt, cc, s,
														 interp_Flag, ivp2ddeCommVoid)
int *n;
/* Subroutine */ int (*fcn) ();
double *x, *y, *h__, *w;
int *nw;
double *aa, *bt, *cc;
int *s;
int interp_Flag;
void* ivp2ddeCommVoid;
{
    /* System generated locals */
    int w_dim1, w_offset, i__1;
    double d__1;

    /* Local variables */
     double temp;
     int i__, k;
    extern /* Subroutine */ int intrp_();
     int intold;

    /* Parameter adjustments */
    --y;
    w_dim1 = *nw;
    w_offset = w_dim1 + 1;
    w -= w_offset;

    /* Function Body */
    temp = *h__ / 1.39816908e12;
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
	w[k + w_dim1 * 13] = y[k] + temp * w[k + w_dim1] * 2.3302818e11;
/* L200: */
    }
    d__1 = *x + *h__ / 6.;
    (*fcn)(n, &d__1, &w[w_dim1 * 13 + 1], &w[(w_dim1 << 1) + 1],
			ivp2ddeCommVoid);
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
	w[k + w_dim1 * 13] = y[k] + temp * (w[k + w_dim1] * 74569017600. + w[
		k + (w_dim1 << 1)] * 298276070400.);
/* L205: */
    }
    d__1 = *x + *h__ * .26666666666666666;
    (*fcn)(n, &d__1, &w[w_dim1 * 13 + 1], &w[w_dim1 * 3 + 1],
			ivp2ddeCommVoid);
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
	w[k + w_dim1 * 13] = y[k] + temp * (w[k + w_dim1] * 1.1651409e12 - w[
		k + (w_dim1 << 1)] * 3.72845088e12 + w[k + w_dim1 * 3] * 
		3.4954227e12);
/* L210: */
    }
    d__1 = *x + *h__ * .66666666666666663;
    (*fcn)(n, &d__1, &w[w_dim1 * 13 + 1], &w[(w_dim1 << 2) + 1],
			ivp2ddeCommVoid);
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
	w[k + w_dim1 * 13] = y[k] + temp * (-w[k + w_dim1] * 3604654659375. + 
		w[k + (w_dim1 << 1)] * 1.28165499e13 - w[k + w_dim1 * 3] * 
		9284716546875. + w[k + (w_dim1 << 2)] * 1237962206250.);
/* L215: */
    }
    d__1 = *x + *h__ * .83333333333333337;
    (*fcn)(n, &d__1, &w[w_dim1 * 13 + 1], &w[w_dim1 * 5 + 1],
			ivp2ddeCommVoid);
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
	w[k + w_dim1 * 13] = y[k] + temp * (-w[k + w_dim1] * 770204740536. + 
		w[k + (w_dim1 << 1)] * 2311639545600. - w[k + w_dim1 * 3] * 
		1.322092233e12 - w[k + (w_dim1 << 2)] * 453006781920. + w[k + 
		w_dim1 * 5] * 326875481856.);
/* L225: */
    }
    d__1 = *x + *h__ / 15.;
    (*fcn)(n, &d__1, &w[w_dim1 * 13 + 1], &w[w_dim1 * 7 + 1],
			ivp2ddeCommVoid);
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
	w[k + w_dim1 * 13] = y[k] + temp * (w[k + w_dim1] * 2.845924389e12 - 
		w[k + (w_dim1 << 1)] * 9.754668e12 + w[k + w_dim1 * 3] * 
		7.897110375e12 - w[k + (w_dim1 << 2)] * 1.9208266e11 + w[k + 
		w_dim1 * 5] * 4.00298976e11 + w[k + w_dim1 * 7] * 2.01586e11);
/* L230: */
    }
    d__1 = *x + *h__;
    (*fcn)(n, &d__1, &w[w_dim1 * 13 + 1], &w[(w_dim1 << 3) + 1],
			ivp2ddeCommVoid);
    i__1 = *n;
    for (k = 1; k <= i__1; ++k) {
	w[k + w_dim1 * 13] = y[k] + temp * (w[k + w_dim1] * 1.04862681e11 + w[
		k + w_dim1 * 3] * 5.4518625e11 + w[k + (w_dim1 << 2)] * 
		4.46637345e11 + w[k + w_dim1 * 5] * 1.88806464e11 + w[k + 
		w_dim1 * 7] * 1.5076875e10 + w[k + (w_dim1 << 3)] * 
		9.7599465e10);
/* L235: */
    }
    d__1 = *x + *h__;
    (*fcn)(n, &d__1, &w[w_dim1 * 13 + 1], &w[w_dim1 * 9 + 1],
			ivp2ddeCommVoid);
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	w[i__ + (w_dim1 << 1)] = y[i__] + *h__ * (w[i__ + w_dim1] * 
		.076562500000000006 + w[i__ + w_dim1 * 3] * 
		.36555815508021389 + w[i__ + (w_dim1 << 2)] * 
		.059895833333333336 + w[i__ + w_dim1 * 5] * 
		-.016879795396419438 + w[i__ + w_dim1 * 7] * 
		.014153079710144928 + w[i__ + (w_dim1 << 3)] * 
		-.030539772727272728 + w[i__ + w_dim1 * 9] * .03125);
/* L240: */
    }
    d__1 = *x + *h__ * .5;
    (*fcn)(n, &d__1, &w[(w_dim1 << 1) + 1], &w[w_dim1 * 10 + 1],
			ivp2ddeCommVoid);
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	w[i__ + w_dim1 * 14] = y[i__] * .040960000000000003 + w[i__ + w_dim1 *
		 13] * .82943999999999996 + w[i__ + (w_dim1 << 1)] * 
		.12959999999999999 + *h__ * (w[i__ + w_dim1] * 
		.0057600000000000004 + w[i__ + w_dim1 * 9] * 
		-.051839999999999997 + w[i__ + w_dim1 * 10] * 
		.051839999999999997);
/* L250: */
    }
    d__1 = *x + *h__ * .9;
    (*fcn)(n, &d__1, &w[w_dim1 * 14 + 1], &w[w_dim1 * 11 + 1],
			ivp2ddeCommVoid);
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	w[i__ + w_dim1 * 14] = y[i__] * .0135675 + w[i__ + w_dim1 * 13] * 
		.95033250000000002 + w[i__ + (w_dim1 << 1)] * .0361 + *h__ * (
		w[i__ + w_dim1] * .0019237499999999999 + w[i__ + w_dim1 * 9] *
		 -.03655125 + w[i__ + w_dim1 * 10] * .016244999999999999);
/* L260: */
    }
    d__1 = *x + *h__ * .95;
    (*fcn)(n, &d__1, &w[w_dim1 * 14 + 1], &w[w_dim1 * 12 + 1],
			ivp2ddeCommVoid);
    if (interp_Flag == 1) {
	interp_Flag = 0;
	d__1 = *x + *h__ * .5;
	intrp_(n, x, &y[1], &d__1, &w[(w_dim1 << 1) + 1], h__, nw, &w[
		w_offset], interp_Flag);
	d__1 = *x + *h__ * .5;
	(*fcn)(n, &d__1, &w[(w_dim1 << 1) + 1], &w[w_dim1 * 15 + 1],
		ivp2ddeCommVoid);
	d__1 = *x + *h__ * .9;
	intrp_(n, x, &y[1], &d__1, &w[(w_dim1 << 1) + 1], h__, nw, &w[
		w_offset], interp_Flag);
	d__1 = *x + *h__ * .9;
	(*fcn)(n, &d__1, &w[(w_dim1 << 1) + 1], &w[(w_dim1 << 4) + 1],
		ivp2ddeCommVoid);
	d__1 = *x + *h__ * .95;
	intrp_(n, x, &y[1], &d__1, &w[(w_dim1 << 1) + 1], h__, nw, &w[
		w_offset], interp_Flag);
	d__1 = *x + *h__ * .95;
	(*fcn)(n, &d__1, &w[(w_dim1 << 1) + 1], &w[w_dim1 * 17 + 1],
		ivp2ddeCommVoid);
	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    w[i__ + w_dim1 * 10] = w[i__ + w_dim1 * 15];
	    w[i__ + w_dim1 * 11] = w[i__ + (w_dim1 << 4)];
	    w[i__ + w_dim1 * 12] = w[i__ + w_dim1 * 17];
/* L270: */
	}
	interp_Flag = 1;
    }
    if (interp_Flag >= 2) {
	intold = interp_Flag;
	interp_Flag = 0;
	d__1 = *x + *h__ * .07;
	intrp_(n, x, &y[1], &d__1, &w[(w_dim1 << 1) + 1], h__, nw, &w[
		w_offset], interp_Flag);
	d__1 = *x + *h__ * .07;
	(*fcn)(n, &d__1, &w[(w_dim1 << 1) + 1], &w[w_dim1 * 15 + 1],
		ivp2ddeCommVoid);
	d__1 = *x + *h__ * .14;
	intrp_(n, x, &y[1], &d__1, &w[(w_dim1 << 1) + 1], h__, nw, &w[
		w_offset], interp_Flag);
	d__1 = *x + *h__ * .14;
	(*fcn)(n, &d__1, &w[(w_dim1 << 1) + 1], &w[(w_dim1 << 4) + 1],
		ivp2ddeCommVoid);
	d__1 = *x + *h__ * .86;
	intrp_(n, x, &y[1], &d__1, &w[(w_dim1 << 1) + 1], h__, nw, &w[
		w_offset], interp_Flag);
	d__1 = *x + *h__ * .86;
	(*fcn)(n, &d__1, &w[(w_dim1 << 1) + 1], &w[w_dim1 * 17 + 1],
		ivp2ddeCommVoid);
	d__1 = *x + *h__ * .93;
	intrp_(n, x, &y[1], &d__1, &w[(w_dim1 << 1) + 1], h__, nw, &w[
		w_offset], interp_Flag);
	d__1 = *x + *h__ * .93;
	(*fcn)(n, &d__1, &w[(w_dim1 << 1) + 1], &w[w_dim1 * 18 + 1],
		ivp2ddeCommVoid);
	interp_Flag = intold;
    }
    return 0;
} /* apform_ */

/* Subroutine */ int deriv_(n, x, y, xout, ypout, htrial, nw, w, interp_Flag)
int *n;
double *x, *y, *xout, *ypout, *htrial;
int *nw;
double *w;
int interp_Flag;
{
    /* System generated locals */
    int w_dim1, w_offset, i__1;
    double d__1, d__2, d__3, d__4, d__5, d__6, d__7, d__8;

    /* Local variables */
     int i__;
     double d0, d1, d2, d3, d4, d5, d6, d7, tau;

    /* Parameter adjustments */
    --ypout;
    --y;
    w_dim1 = *nw;
    w_offset = w_dim1 + 1;
    w -= w_offset;

    /* Function Body */
    tau = (*xout - *x) / *htrial;
    if (interp_Flag == 0 || interp_Flag == 1) {
/* Computing 2nd power */
	d__1 = tau - 1.;
	d0 = -40. / (*htrial * 17.) * (tau - 1.) * ((((tau * 20. - 40.4) * 
		tau + 23.1) * tau - 1.7) * tau - .85) - d__1 * d__1 / (*
		htrial * 17.) * (((tau * 1600. - 2424.) * tau + 924.) * tau - 
		34.);
/* Computing 2nd power */
	d__1 = tau - 1.;
	d1 = ((tau * 3. - 4.) * tau + 1.) * -.22933149868134389 * (((tau * 
		15.1 - 32.542) * tau + 21.903) * tau - 4.3605) - tau * (d__1 *
		 d__1) / 8721. * ((tau * 90600. - 130168.) * tau + 43806.);
/* Computing 2nd power */
	d__1 = tau;
	d2 = 40. / (*htrial * 17.) * tau * ((((tau * 20. - 80.4) * tau + 
		123.9) * tau - 88.3) * tau + 25.65) + d__1 * d__1 / (*htrial *
		 17.) * (((tau * 1600. - 4824.) * tau + 4956.) * tau - 1766.);
/* Computing 2nd power */
	d__1 = tau;
	d3 = (tau * 3. - 2.) * 39.215686274509807 * tau * (((tau * 1.9 - 
		3.698) * tau + 2.08) * tau - .2565) + (tau - 1.) * (d__1 * 
		d__1) / 51. * ((tau * 11400. - 14792.) * tau + 4160.);
/* Computing 2nd power */
	d__1 = tau * (tau - 1.);
	d4 = tau * (tau - 1.) * (tau * 2. - 1.) * -17.429193899782135 * ((tau 
		* 2.3 - 4.136) * tau + 1.8596250000000001) - d__1 * d__1 / 
		918. * (tau * 36800. - 33088.);
/* Computing 2nd power */
	d__1 = tau * (tau - 1.);
	d5 = tau * .27233115468409586 * (tau - 1.) * (tau * 2. - 1.) * ((tau *
		 800. - 800.) * tau + 57.) + d__1 * d__1 * .13616557734204793 
		* (tau * 1600. - 800.);
/* Computing 2nd power */
	d__1 = tau * (tau - 1.);
	d6 = tau * -1.8346519894507511 * (tau - 1.) * (tau * 2. - 1.) * ((tau 
		* 200. - 200.) * tau + 27.) - d__1 * d__1 * 
		.91732599472537557 * (tau * 400. - 200.);
	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    ypout[i__] = d0 * y[i__] + d1 * w[i__ + w_dim1] + d2 * w[i__ + 
		    w_dim1 * 13] + d3 * w[i__ + w_dim1 * 9] + d4 * w[i__ + 
		    w_dim1 * 10] + d5 * w[i__ + w_dim1 * 11] + d6 * w[i__ + 
		    w_dim1 * 12];
/* L40: */
	}
    }
    if (interp_Flag >= 2) {
/* Computing 2nd power */
	d__1 = tau;
/* Computing 3rd power */
	d__2 = tau, d__3 = d__2;
/* Computing 4th power */
	d__4 = tau, d__4 *= d__4;
/* Computing 5th power */
	d__5 = tau, d__6 = d__5, d__5 *= d__5;
/* Computing 6th power */
	d__7 = tau, d__7 *= d__7, d__8 = d__7;
	d0 = tau * -3.4591840723415901 + d__1 * d__1 * 85.326416877910958 - 
		d__3 * (d__2 * d__2) * 605.06725701582536 + d__4 * d__4 * 
		1405.8656070196291 - d__6 * (d__5 * d__5) * 
		1323.9983742140598 + d__8 * (d__7 * d__7) * 
		441.33279140468665;
/* Computing 2nd power */
	d__1 = tau;
/* Computing 3rd power */
	d__2 = tau, d__3 = d__2;
/* Computing 4th power */
	d__4 = tau, d__4 *= d__4;
/* Computing 5th power */
	d__5 = tau, d__6 = d__5, d__5 *= d__5;
/* Computing 6th power */
	d__7 = tau, d__7 *= d__7, d__8 = d__7;
	d1 = 1. - tau * 26.929500102568273 + d__1 * d__1 * 230.73353644538 - 
		d__3 * (d__2 * d__2) * 802.2278040365893 + d__4 * d__4 * 
		1302.4135761454122 - d__6 * (d__5 * d__5) * 
		993.69325460885295 + d__8 * (d__7 * d__7) * 
		288.70344615721848;
/* Computing 2nd power */
	d__1 = tau;
/* Computing 3rd power */
	d__2 = tau, d__3 = d__2;
/* Computing 4th power */
	d__4 = tau, d__4 *= d__4;
/* Computing 5th power */
	d__5 = tau, d__6 = d__5, d__5 *= d__5;
/* Computing 6th power */
	d__7 = tau, d__7 *= d__7, d__8 = d__7;
	d2 = tau * 3.4591840723415901 - d__1 * d__1 * 85.326416877910958 + 
		d__3 * (d__2 * d__2) * 605.06725701582536 - d__4 * d__4 * 
		1405.8656070196291 + d__6 * (d__5 * d__5) * 
		1323.9983742140598 - d__8 * (d__7 * d__7) * 
		441.33279140468665;
/* Computing 2nd power */
	d__1 = tau;
/* Computing 3rd power */
	d__2 = tau, d__3 = d__2;
/* Computing 4th power */
	d__4 = tau, d__4 *= d__4;
/* Computing 5th power */
	d__5 = tau, d__6 = d__5, d__5 *= d__5;
/* Computing 6th power */
	d__7 = tau, d__7 *= d__7, d__8 = d__7;
	d3 = tau * -1.2628691591181247 + d__1 * d__1 * 32.150727477832 - d__3 
		* (d__2 * d__2) * 244.56287760089882 + d__4 * d__4 * 
		664.49899545942424 - d__6 * (d__5 * d__5) * 
		738.52742233445781 + d__8 * (d__7 * d__7) * 
		288.70344615721848;
/* Computing 2nd power */
	d__1 = tau;
/* Computing 3rd power */
	d__2 = tau, d__3 = d__2;
/* Computing 4th power */
	d__4 = tau, d__4 *= d__4;
/* Computing 5th power */
	d__5 = tau, d__6 = d__5, d__5 *= d__5;
/* Computing 6th power */
	d__7 = tau, d__7 *= d__7, d__8 = d__7;
	d4 = tau * 42.54017911328495 - d__1 * d__1 * 532.66053730867577 + 
		d__3 * (d__2 * d__2) * 2077.5366317004246 - d__4 * d__4 * 
		3536.7905093613813 + d__6 * (d__5 * d__5) * 
		2762.5639915855372 - d__8 * (d__7 * d__7) * 
		813.18975572918964;
/* Computing 2nd power */
	d__1 = tau;
/* Computing 3rd power */
	d__2 = tau, d__3 = d__2;
/* Computing 4th power */
	d__4 = tau, d__4 *= d__4;
/* Computing 5th power */
	d__5 = tau, d__6 = d__5, d__5 *= d__5;
/* Computing 6th power */
	d__7 = tau, d__7 *= d__7, d__8 = d__7;
	d5 = tau * -17.519258831808383 + d__1 * d__1 * 348.72164828013916 - 
		d__3 * (d__2 * d__2) * 1602.5783342340903 + d__4 * d__4 * 
		2970.28211484141 - d__6 * (d__5 * d__5) * 2444.0588753299648 
		+ d__8 * (d__7 * d__7) * 745.15270527431448;
/* Computing 2nd power */
	d__1 = tau;
/* Computing 3rd power */
	d__2 = tau, d__3 = d__2;
/* Computing 4th power */
	d__4 = tau, d__4 *= d__4;
/* Computing 5th power */
	d__5 = tau, d__6 = d__5, d__5 *= d__5;
/* Computing 6th power */
	d__7 = tau, d__7 *= d__7, d__8 = d__7;
	d6 = tau * -3.9393493879012955 + d__1 * d__1 * 99.38116044139656 - 
		d__3 * (d__2 * d__2) * 741.01547731819073 + d__4 * d__4 * 
		1927.2783173063031 - d__6 * (d__5 * d__5) * 
		2026.8573563159221 + d__8 * (d__7 * d__7) * 
		745.15270527431448;
/* Computing 2nd power */
	d__1 = tau;
/* Computing 3rd power */
	d__2 = tau, d__3 = d__2;
/* Computing 4th power */
	d__4 = tau, d__4 *= d__4;
/* Computing 5th power */
	d__5 = tau, d__6 = d__5, d__5 *= d__5;
/* Computing 6th power */
	d__7 = tau, d__7 *= d__7, d__8 = d__7;
	d7 = tau * 3.651614295769539 - d__1 * d__1 * 93.000118458161012 + 
		d__3 * (d__2 * d__2) * 707.78060447351947 - d__4 * d__4 * 
		1921.8168873715388 + d__6 * (d__5 * d__5) * 
		2116.5745427896004 - d__8 * (d__7 * d__7) * 
		813.18975572918964;
	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    ypout[i__] = d0 * y[i__] / *htrial + d1 * w[i__ + w_dim1] + d2 * 
		    w[i__ + w_dim1 * 13] / *htrial + d3 * w[i__ + w_dim1 * 9] 
		    + d4 * w[i__ + w_dim1 * 15] + d5 * w[i__ + (w_dim1 << 4)] 
		    + d6 * w[i__ + w_dim1 * 17] + d7 * w[i__ + w_dim1 * 18];
/* L42: */
	}
    }
    return 0;
} /* deriv_ */

/* Subroutine */ int intrp_(n, x, y, xout, yout, htrial, nw, w, interp_Flag)
int *n;
double *x, *y, *xout, *yout, *htrial;
int *nw;
double *w;
int interp_Flag;
{
    /* System generated locals */
    int w_dim1, w_offset, i__1;
    double d__1, d__2, d__3, d__4, d__5, d__6, d__7, d__8, d__9, d__10;

    /* Local variables */
     int i__;
     double d0, d1, d2, d3, d4, d5, d6, d7, tau;

    /* Parameter adjustments */
    --yout;
    --y;
    w_dim1 = *nw;
    w_offset = w_dim1 + 1;
    w -= w_offset;

    /* Function Body */
    tau = (*xout - *x) / *htrial;
    if (interp_Flag == 0 || interp_Flag == 1) {
/* Computing 2nd power */
	d__1 = tau - 1.;
	d0 = d__1 * d__1 * -1.1764705882352942 * ((((tau * 20. - 40.4) * tau 
		+ 23.1) * tau - 1.7) * tau - .85);
/* Computing 2nd power */
	d__1 = tau - 1.;
	d1 = tau * -.22933149868134389 * (d__1 * d__1) * (((tau * 15.1 - 
		32.542) * tau + 21.903) * tau - 4.3605) * *htrial;
/* Computing 2nd power */
	d__1 = tau;
	d2 = d__1 * d__1 * 1.1764705882352942 * ((((tau * 20. - 80.4) * tau + 
		123.9) * tau - 88.3) * tau + 25.65);
/* Computing 2nd power */
	d__1 = tau;
	d3 = (tau - 1.) * 39.215686274509807 * (d__1 * d__1) * (((tau * 1.9 - 
		3.698) * tau + 2.08) * tau - .2565) * *htrial;
/* Computing 2nd power */
	d__1 = tau;
/* Computing 2nd power */
	d__2 = tau - 1.;
	d4 = d__1 * d__1 * -8.7145969498910674 * (d__2 * d__2) * ((tau * 2.3 
		- 4.136) * tau + 1.8596250000000001) * *htrial;
/* Computing 2nd power */
	d__1 = tau;
/* Computing 2nd power */
	d__2 = tau - 1.;
	d5 = d__1 * d__1 * 54.466230936819173 * (d__2 * d__2) * ((tau * 2. - 
		2.) * tau + .1425) * *htrial;
/* Computing 2nd power */
	d__1 = tau;
/* Computing 2nd power */
	d__2 = tau - 1.;
	d6 = d__1 * d__1 * -91.732599472537558 * (d__2 * d__2) * ((tau * 2. - 
		2.) * tau + .27) * *htrial;
	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    yout[i__] = d0 * y[i__] + d1 * w[i__ + w_dim1] + d2 * w[i__ + 
		    w_dim1 * 13] + d3 * w[i__ + w_dim1 * 9] + d4 * w[i__ + 
		    w_dim1 * 10] + d5 * w[i__ + w_dim1 * 11] + d6 * w[i__ + 
		    w_dim1 * 12];
/* L40: */
	}
    }
    if (interp_Flag >= 2) {
/* Computing 2nd power */
	d__1 = tau;
/* Computing 3rd power */
	d__2 = tau, d__3 = d__2;
/* Computing 4th power */
	d__4 = tau, d__4 *= d__4;
/* Computing 5th power */
	d__5 = tau, d__6 = d__5, d__5 *= d__5;
/* Computing 6th power */
	d__7 = tau, d__7 *= d__7, d__8 = d__7;
/* Computing 7th power */
	d__9 = tau, d__10 = d__9, d__9 *= d__9, d__10 *= d__9;
	d0 = 1. - d__1 * d__1 * 1.729592036170795 + d__3 * (d__2 * d__2) * 
		28.442138959303652 - d__4 * d__4 * 151.26681425395634 + d__6 *
		 (d__5 * d__5) * 281.17312140392585 - d__8 * (d__7 * d__7) * 
		220.66639570234332 + d__10 * (d__9 * d__9) * 
		63.047541629240946;
/* Computing 2nd power */
	d__1 = tau;
/* Computing 3rd power */
	d__2 = tau, d__3 = d__2;
/* Computing 4th power */
	d__4 = tau, d__4 *= d__4;
/* Computing 5th power */
	d__5 = tau, d__6 = d__5, d__5 *= d__5;
/* Computing 6th power */
	d__7 = tau, d__7 *= d__7, d__8 = d__7;
/* Computing 7th power */
	d__9 = tau, d__10 = d__9, d__9 *= d__9, d__10 *= d__9;
	d1 = tau - d__1 * d__1 * 13.464750051284136 + d__3 * (d__2 * d__2) * 
		76.911178815126675 - d__4 * d__4 * 200.55695100914733 + d__6 *
		 (d__5 * d__5) * 260.48271522908243 - d__8 * (d__7 * d__7) * 
		165.61554243480882 + d__10 * (d__9 * d__9) * 
		41.243349451031207;
/* Computing 2nd power */
	d__1 = tau;
/* Computing 3rd power */
	d__2 = tau, d__3 = d__2;
/* Computing 4th power */
	d__4 = tau, d__4 *= d__4;
/* Computing 5th power */
	d__5 = tau, d__6 = d__5, d__5 *= d__5;
/* Computing 6th power */
	d__7 = tau, d__7 *= d__7, d__8 = d__7;
/* Computing 7th power */
	d__9 = tau, d__10 = d__9, d__9 *= d__9, d__10 *= d__9;
	d2 = d__1 * d__1 * 1.729592036170795 - d__3 * (d__2 * d__2) * 
		28.442138959303652 + d__4 * d__4 * 151.26681425395634 - d__6 *
		 (d__5 * d__5) * 281.17312140392585 + d__8 * (d__7 * d__7) * 
		220.66639570234332 - d__10 * (d__9 * d__9) * 
		63.047541629240946;
/* Computing 2nd power */
	d__1 = tau;
/* Computing 3rd power */
	d__2 = tau, d__3 = d__2;
/* Computing 4th power */
	d__4 = tau, d__4 *= d__4;
/* Computing 5th power */
	d__5 = tau, d__6 = d__5, d__5 *= d__5;
/* Computing 6th power */
	d__7 = tau, d__7 *= d__7, d__8 = d__7;
/* Computing 7th power */
	d__9 = tau, d__10 = d__9, d__9 *= d__9, d__10 *= d__9;
	d3 = d__1 * d__1 * -.63143457955906235 + d__3 * (d__2 * d__2) * 
		10.716909159277334 - d__4 * d__4 * 61.140719400224704 + d__6 *
		 (d__5 * d__5) * 132.89979909188486 - d__8 * (d__7 * d__7) * 
		123.08790372240964 + d__10 * (d__9 * d__9) * 
		41.243349451031207;
/* Computing 2nd power */
	d__1 = tau;
/* Computing 3rd power */
	d__2 = tau, d__3 = d__2;
/* Computing 4th power */
	d__4 = tau, d__4 *= d__4;
/* Computing 5th power */
	d__5 = tau, d__6 = d__5, d__5 *= d__5;
/* Computing 6th power */
	d__7 = tau, d__7 *= d__7, d__8 = d__7;
/* Computing 7th power */
	d__9 = tau, d__10 = d__9, d__9 *= d__9, d__10 *= d__9;
	d4 = d__1 * d__1 * 21.270089556642475 - d__3 * (d__2 * d__2) * 
		177.55351243622525 + d__4 * d__4 * 519.38415792510614 - d__6 *
		 (d__5 * d__5) * 707.35810187227628 + d__8 * (d__7 * d__7) * 
		460.42733193092289 - d__10 * (d__9 * d__9) * 
		116.16996510416995;
/* Computing 2nd power */
	d__1 = tau;
/* Computing 3rd power */
	d__2 = tau, d__3 = d__2;
/* Computing 4th power */
	d__4 = tau, d__4 *= d__4;
/* Computing 5th power */
	d__5 = tau, d__6 = d__5, d__5 *= d__5;
/* Computing 6th power */
	d__7 = tau, d__7 *= d__7, d__8 = d__7;
/* Computing 7th power */
	d__9 = tau, d__10 = d__9, d__9 *= d__9, d__10 *= d__9;
	d5 = d__1 * d__1 * -8.7596294159041914 + d__3 * (d__2 * d__2) * 
		116.24054942671306 - d__4 * d__4 * 400.64458355852258 + d__6 *
		 (d__5 * d__5) * 594.05642296828194 - d__8 * (d__7 * d__7) * 
		407.34314588832746 + d__10 * (d__9 * d__9) * 
		106.45038646775922;
/* Computing 2nd power */
	d__1 = tau;
/* Computing 3rd power */
	d__2 = tau, d__3 = d__2;
/* Computing 4th power */
	d__4 = tau, d__4 *= d__4;
/* Computing 5th power */
	d__5 = tau, d__6 = d__5, d__5 *= d__5;
/* Computing 6th power */
	d__7 = tau, d__7 *= d__7, d__8 = d__7;
/* Computing 7th power */
	d__9 = tau, d__10 = d__9, d__9 *= d__9, d__10 *= d__9;
	d6 = d__1 * d__1 * -1.9696746939506478 + d__3 * (d__2 * d__2) * 
		33.12705348046552 - d__4 * d__4 * 185.25386932954768 + d__6 * 
		(d__5 * d__5) * 385.4556634612606 - d__8 * (d__7 * d__7) * 
		337.80955938598703 + d__10 * (d__9 * d__9) * 
		106.45038646775922;
/* Computing 2nd power */
	d__1 = tau;
/* Computing 3rd power */
	d__2 = tau, d__3 = d__2;
/* Computing 4th power */
	d__4 = tau, d__4 *= d__4;
/* Computing 5th power */
	d__5 = tau, d__6 = d__5, d__5 *= d__5;
/* Computing 6th power */
	d__7 = tau, d__7 *= d__7, d__8 = d__7;
/* Computing 7th power */
	d__9 = tau, d__10 = d__9, d__9 *= d__9, d__10 *= d__9;
	d7 = d__1 * d__1 * 1.8258071478847695 - d__3 * (d__2 * d__2) * 
		31.000039486053669 + d__4 * d__4 * 176.94515111837987 - d__6 *
		 (d__5 * d__5) * 384.36337747430775 + d__8 * (d__7 * d__7) * 
		352.76242379826675 - d__10 * (d__9 * d__9) * 
		116.16996510416995;
	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    yout[i__] = d0 * y[i__] + *htrial * d1 * w[i__ + w_dim1] + d2 * w[
		    i__ + w_dim1 * 13] + *htrial * d3 * w[i__ + w_dim1 * 9] + 
		    *htrial * d4 * w[i__ + w_dim1 * 15] + *htrial * d5 * w[
		    i__ + (w_dim1 << 4)] + *htrial * d6 * w[i__ + w_dim1 * 17]
		     + *htrial * d7 * w[i__ + w_dim1 * 18];
/* L42: */
	}
    }
    return 0;
} /* intrp_ */

/* Subroutine */ int defect_(n, fcn, x, y, h__, tau, ypout, dfct, nw, w,
														 interp_Flag, ivp2ddeCommVoid)
int *n;
/* Subroutine */ int (*fcn) ();
double *x, *y, *h__, *tau, *ypout, *dfct;
int *nw;
double *w;
int interp_Flag;
void* ivp2ddeCommVoid;
{
    /* System generated locals */
    int w_dim1, w_offset, i__1;

    /* Local variables */
     double xout;
     int i__;
    extern /* Subroutine */ int deriv_(), intrp_();

    /* Parameter adjustments */
    --dfct;
    --ypout;
    --y;
    w_dim1 = *nw;
    w_offset = w_dim1 + 1;
    w -= w_offset;

    /* Function Body */
    xout = *x + *tau * *h__;
    intrp_(n, x, &y[1], &xout, &ypout[1], h__, nw, &w[w_offset], interp_Flag);
    (*fcn)(n, &xout, &ypout[1], &dfct[1], ivp2ddeCommVoid);
    deriv_(n, x, &y[1], &xout, &ypout[1], h__, nw, &w[w_offset], interp_Flag);
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
	dfct[i__] -= ypout[i__];
/* L10: */
    }
    return 0;
} /* defect_ */

